# PIC16C84 ASM(PASS 4) (by Y. Ikushima)
BEGIN{	rm=":"; mode=0; la = 0; rl = 0; topa = 0; c_sum = 0; }
{
	#؂"C"
	if( $1 == "C" ) {
		mode = 1;
		next;
	}
	#؂"D"
	if( $1 == "D" ) {
		mode = 2;
		next;
	}

	#vOE
	if ( mode == 0 ) {
		la = hex_bin($1);
		data[rl] = bin_hex($2);
		data_out();
	}
	
	#RtBO[VEq[Y
	if ( mode == 1 ) {
		if ($1 != "E") {
			la = hex_bin($1) + 8192;
			data[rl] = bin_hex($2);
		} else {
			la = 8704;
			data[rl] = 0;
		}
		data_out();
	}

	#f[^E
	if ( mode == 2 ) {
		if ($1 != "E") {
			la = hex_bin($1) + 8448;
			data[rl] = bin_hex($2);
		} else {
			la = 8740;
			data[rl] = 0;
		}
		data_out();
	}
}

END{
	#ŏIR[h̕\
	printf(":00000001FF\n");
}
#[U`֐
#QiPSrbgQoCgf[^ɕϊ
function bin_hex(dc) {
	dout = 0; bi = 256;
	for(i = 0 ; i < 8 ; i ++) {
		if ( substr(dc,14-i,1) == "1" ) {
			dout += bi;
		}
		bi *= 2;
	}
	bi = 1;
	for(i = 8 ; i < 14 ; i ++) {
		if ( substr(dc,14 - i,1) == "1" ) {
			dout += bi;
		}
		bi *= 2;
	}
	return(dout);
}
#PUiPOiɕϊ
function hex_bin(f){
	i = length(f);
	d = dej(substr(f,i-2,1)) * 256 + dej(substr(f,i-1,1))*16;
	d += dej(substr(f,i,1));
	return(d);
}
#`FbNETpPUiQ\
function c_hex2(ad) {
	cd = ad - int(ad / 256) * 256;
	cd = 255 - cd + 1;
	printf("%02X\n",cd);
}
#PUiPOiɕϊ
function dej(s){
	d =index("0123456789ABCDEF",s);
	if (d == 0) {
		printf("dej error -----------------------------!!!\n");
	}
	return(d - 1);
}
#f[^̏o
function data_out(){
	if (((((topa + rl) != la) || (rl == 8)) && (la != 0))) {
		c_sum = 0;
		printf(":");
		printf("%02X",rl * 2);
		c_sum += rl * 2
		printf("%04X",(topa * 2));
		c_sum += (topa * 2) - int((topa * 2) / 256) * 256
		c_sum += int((topa * 2) / 256);
		printf("00");
		for(i = 0 ; i < rl ; i ++) {
			printf("%04X",data[i]);
			c_sum += data[i] - int(data[i] / 256) * 256;
			c_sum += int(data[i] / 256);
		}
		c_hex2(c_sum);
		topa = la

		data[0] = data[rl];
		rl = 0;
		la = $1;
	}
	rl ++;
}
